<?php
/**
 * @package Demo Import
 * @since 1.0.0
 */

class ThemeWhizzie {

	protected $version = '1.1.0';

	/** @var string Current theme name, used as namespace in actions. */
	protected $theme_name = '';
	protected $theme_title = '';

	/** @var string Demo Import page slug and title. */
	protected $page_slug = '';
	protected $page_title = '';

	/** @var array Demo Import steps set by user. */
	protected $config_steps = array();

	/**
	 * Relative plugin url for this plugin folder
	 * @since 1.0.0
	 * @var string
	*/
	protected $plugin_url = '';
	protected $plugin_path = '';
	public $parent_slug;
	/**
	 * TGMPA instance storage
	 *
	 * @var object
	*/
	protected $tgmpa_instance;

	/**
	 * TGMPA Menu slug
	 *
	 * @var string
	*/
	protected $tgmpa_menu_slug = 'tgmpa-install-plugins';

	/**
	 * TGMPA Menu url
	 *
	 * @var string
	*/
	protected $tgmpa_url = 'themes.php?page=tgmpa-install-plugins';

	/**
	 * Constructor
	 *
	 * @param $fashion_outfit_config	Our config parameters
	*/
	public function __construct( $fashion_outfit_config ) {
		$this->set_vars( $fashion_outfit_config );
		$this->init();

		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}

	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $fashion_outfit_config	Our config parameters
	*/
	public function set_vars( $fashion_outfit_config ) {

		require_once trailingslashit( WHIZZIE_DIR ) . 'tgm/tgm.php';

		if( isset( $fashion_outfit_config['page_slug'] ) ) {
			$this->page_slug = esc_attr( $fashion_outfit_config['page_slug'] );
		}
		if( isset( $fashion_outfit_config['page_title'] ) ) {
			$this->page_title = esc_attr( $fashion_outfit_config['page_title'] );
		}
		if( isset( $fashion_outfit_config['steps'] ) ) {
			$this->config_steps = $fashion_outfit_config['steps'];
		}

		$this->plugin_path = trailingslashit( dirname( __FILE__ ) );
		$relative_url = str_replace( get_template_directory(), '', $this->plugin_path );
		$this->plugin_url = trailingslashit( get_template_directory_uri() . $relative_url );
		$current_theme = wp_get_theme();
		$this->theme_title = $current_theme->get( 'Name' );
		$this->theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->page_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_page_slug', $this->theme_name . '-demoimport' );
		$this->parent_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/**
	 * Hooks and filters
	 * @since 1.0.0
	*/
	public function init() {

		if ( class_exists( 'TGM_Plugin_Activation' ) && isset( $GLOBALS['tgmpa'] ) ) {
			add_action( 'init', array( $this, 'get_tgmpa_instance' ), 30 );
			add_action( 'init', array( $this, 'set_tgmpa_url' ), 40 );
		}

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'admin_init', array( $this, 'get_plugins' ), 30 );
		add_filter( 'tgmpa_load', array( $this, 'tgmpa_load' ), 10, 1 );
		add_action( 'wp_ajax_setup_plugins', array( $this, 'setup_plugins' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'demo-import-style', get_template_directory_uri() . '/demo-import/assets/css/demo-import-style.css');
		wp_register_script( 'demo-import-script', get_template_directory_uri() . '/demo-import/assets/js/demo-import-script.js', array( 'jquery' ), time() );
		wp_localize_script(
			'demo-import-script',
			'fashion_outfit_whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'fashion-outfit' )
			)
		);
		wp_enqueue_script( 'demo-import-script' );
	}

	public function tgmpa_load( $status ) {
		return is_admin() || current_user_can( 'install_themes' );
	}

	/**
	 * Get configured TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function get_tgmpa_instance() {
		$this->tgmpa_instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
	}

	/**
	 * Update $tgmpa_menu_slug and $tgmpa_parent_slug from TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function set_tgmpa_url() {
		$this->tgmpa_menu_slug = ( property_exists( $this->tgmpa_instance, 'menu' ) ) ? $this->tgmpa_instance->menu : $this->tgmpa_menu_slug;
		$this->tgmpa_menu_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_tgmpa_menu_slug', $this->tgmpa_menu_slug );
		$tgmpa_parent_slug = ( property_exists( $this->tgmpa_instance, 'parent_slug' ) && $this->tgmpa_instance->parent_slug !== 'themes.php' ) ? 'admin.php' : 'themes.php';
		$this->tgmpa_url = apply_filters( $this->theme_name . '_theme_setup_wizard_tgmpa_url', $tgmpa_parent_slug . '?page=' . $this->tgmpa_menu_slug );
	}


	/**  Make a modal screen for the wizard **/
	public function menu_page() {
		add_menu_page( esc_html( $this->page_title ), esc_html( $this->page_title ), 'manage_options', $this->page_slug, array( $this, 'fashion_outfit_guide' ) ,'',40);
	}

	/*** Make an interface for the wizard ***/
	public function wizard_page() {

		tgmpa_load_bulk_installer();

		// install plugins with TGM.
		if ( ! class_exists( 'TGM_Plugin_Activation' ) || ! isset( $GLOBALS['tgmpa'] ) ) {
			die( 'Failed to find TGM' );
		}
		$url = wp_nonce_url( add_query_arg( array( 'plugins' => 'go' ) ), 'whizzie-setup' );

		// copied from TGM
		$method = ''; // Leave blank so WP_Filesystem can populate it as necessary.
		$fields = array_keys( $_POST ); // Extra fields to pass to WP_Filesystem.
		if ( false === ( $creds = request_filesystem_credentials( esc_url_raw( $url ), $method, false, false, $fields ) ) ) {
			return true; // Stop the normal page form from displaying, credential request form will be shown.
		}
		// Now we have some credentials, setup WP_Filesystem.
		if ( ! WP_Filesystem( $creds ) ) {
			// Our credentials were no good, ask the user for them again.
			request_filesystem_credentials( esc_url_raw( $url ), $method, true, false, $fields );
			return true;
		}

		/* If we arrive here, we have the filesystem */ ?>
		<div class="wrap">
			<?php echo '<div class="whizzie-wrap">';
				// The wizard is a list with only one item visible at a time
				$steps = $this->get_steps();
				echo '<ul class="whizzie-nav wizard-icon-nav">';?>

				<?php
					$stepI=1;
					foreach( $steps as $step ) {
						$stepAct=($stepI ==1)? 1 : 0;
						if( isset( $step['icon_text'] ) && $step['icon_text'] ) {
							echo '<li class="commom-cls nav-step-' . esc_attr( $step['id'] ) . '" wizard-steps="step-'.esc_attr( $step['id'] ).'" data-enable="'.$stepAct.'">
							<p>'.esc_attr( $step['icon_text'] ).'</p>
							</li>';
						}
					$stepI++;}
			 	echo '</ul>';
				echo '<ul class="whizzie-menu wizard-menu-page">';
				foreach( $steps as $step ) {
					$class = 'step step-' . esc_attr( $step['id'] );
					echo '<li data-step="' . esc_attr( $step['id'] ) . '" class="' . esc_attr( $class ) . '" >';

						$content = call_user_func( array( $this, $step['view'] ) );
						if( isset( $content['summary'] ) ) {
							printf(
								'<div class="summary">%s</div>',
								wp_kses_post( $content['summary'] )
							);
						}
						if( isset( $content['detail'] ) ) {
							// Add a link to see more detail
							printf( '<div class="wz-require-plugins">');
							printf(
								'<div class="detail">%s</div>',
								$content['detail'] // Need to escape this
							);
							printf('</div>');
						}
						printf('<div class="wizard-button-wrapper">');
							// The next button
							if( isset( $step['button_text'] ) && $step['button_text'] ) {
								printf(
									'<div class="button-wrap"><a href="#" class="button button-primary do-it" data-callback="%s" data-step="%s">%s</a></div>',
									esc_attr( $step['callback'] ),
									esc_attr( $step['id'] ),
									esc_html( $step['button_text'] )
								);
							}

							if( isset( $step['button_text_one'] )) {
								printf(
									'<div class="button-wrap button-wrap-one">
										<a href="#" class="button button-primary do-it" data-callback="install_widgets" data-step="widgets"><p class="demo-type-text">%s</p></a>
									</div>',
									esc_html( $step['button_text_one'] )
								);
							}
						printf('</div>');
					echo '</li>';
				}
				echo '</ul>';
				?>
				<div class="step-loading"><span class="spinner">
					<img src="<?php echo esc_url(get_template_directory_uri().'/demo-import/assets/images/Spinner-Animaion.gif'); ?>">
				</span></div>
			<?php echo '</div>';?>
		</div>
	<?php }

	/**
	 * Set options for the steps
	 * @return Array
	*/
	public function get_steps() {
		$dev_steps = $this->config_steps;
		$steps = array(
			'plugins' => array(
				'id'			=> 'plugins',
				'title'			=> __( 'Plugins', 'fashion-outfit' ),
				'icon'			=> 'admin-plugins',
				'view'			=> 'get_step_plugins',
				'callback'		=> 'install_plugins',
				'button_text'	=> __( 'Install Plugins', 'fashion-outfit' ),
				'can_skip'		=> true,
				'icon_text'      => 'Plugins'
			),
			'widgets' => array(
				'id'			=> 'widgets',
				'title'			=> __( 'Customizer', 'fashion-outfit' ),
				'icon'			=> 'welcome-widgets-menus',
				'view'			=> 'get_step_widgets',
				'callback'		=> 'install_widgets',
				'button_text_one'	=> __( 'Import Demo', 'fashion-outfit' ),

				'can_skip'		=> true,
				'icon_text'      => 'Import Demo'
			),
			'done' => array(
				'id'			=> 'done',
				'title'			=> __( 'All Done', 'fashion-outfit' ),
				'icon'			=> 'yes',
				'view'			=> 'get_step_done',
				'callback'		=> '',
				'icon_text'      => 'Done'
			)
		);

		// Iterate through each step and replace with dev config values
		if( $dev_steps ) {
			// Configurable elements - these are the only ones the dev can update from config.php
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $dev_steps as $dev_step ) {
				// We can only proceed if an ID exists and matches one of our IDs
				if( isset( $dev_step['id'] ) ) {
					$id = $dev_step['id'];
					if( isset( $steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $dev_step[$element] ) ) {
								$steps[$id][$element] = $dev_step[$element];
							}
						}
					}
				}
			}
		}
		return $steps;
	}

	/*** Print the content for the intro step ***/
		public function get_step_importer() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('Thank you for choosing this Fashion Outfit Theme. Using this quick setup wizard, you will be able to configure your new website and get it running in just a few minutes. Just follow these simple steps mentioned in the wizard and get started with your website.','fashion-outfit'); ?>
			</p>
		</div>
	<?php }

	/**
	 * Get the content for the plugins step
	 * @return $content Array
	*/
	public function get_step_plugins() {
		$plugins = $this->get_plugins();
		$content = array(); ?>
			<div class="summary">
				<p>
					<?php esc_html_e('Install Recommended Plugins:	','fashion-outfit') ?>
				</p>
			</div>
		<?php // The detail element is initially hidden from the user
		$content['detail'] = '<span class="wizard-plugin-count">'.count($plugins['all']).'</span><ul class="whizzie-do-plugins">';
		// Add each plugin into a list
		foreach( $plugins['all'] as $slug=>$plugin ) {
			$content['detail'] .= '<li data-slug="' . esc_attr( $slug ) . '">' . esc_html( $plugin['name'] ) . '<div class="wizard-plugin-title">';

			$content['detail'] .= '<span class="wizard-plugin-status">Installation Required</span><i class="spinner"></i></div></li>';
		}
		$content['detail'] .= '</ul>';

		return $content;
	}

	/**    Print the content for the intro step     **/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('This theme allows you to import demo content and add widgets. Install them using the button below. You can also update or deactivate them using the Customizer.','fashion-outfit'); ?>
			</p>
		</div>
	<?php }

	/***  Print the content for the final step  ***/
	public function get_step_done() { ?>

		<div class="setup-finish">
			<p>
				<?php echo esc_html('Your demo content has been imported successfully. Click the finish button for more information.'); ?>
			</p>
			<div class="finish-buttons">
				<a href="<?php echo esc_url( admin_url( 'themes.php?page=fashion-outfit-getstart-page' ) ); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('About Fashion Outfit','fashion-outfit') ?></a>
				<a href="<?php echo esc_url(admin_url('/customize.php')); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Customize Your Demo','fashion-outfit') ?></a>
				<a href="" class="wz-btn-builder" target="_blank"><?php esc_html_e('Customize Your Demo','fashion-outfit'); ?></a>
				<a href="<?php echo esc_url(home_url()); ?>" class="wz-btn-visit-site" target="_blank"><?php esc_html_e('Visit Your Site','fashion-outfit'); ?></a>
			</div>
			<div class="finish-buttons">
				<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary"><?php esc_html_e('Finish','fashion-outfit'); ?></a>
			</div>
		</div>

	<?php }

	/***  Get the plugins registered with TGMPA  ***/
	public function get_plugins() {
		$instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
		$plugins = array(
			'all' 		=> array(),
			'install'	=> array(),
			'update'	=> array(),
			'activate'	=> array()
		);
		foreach( $instance->plugins as $slug=>$plugin ) {
			if( $instance->is_plugin_active( $slug ) && false === $instance->does_plugin_have_update( $slug ) ) {
				// Plugin is installed and up to date
				continue;
			} else {
				$plugins['all'][$slug] = $plugin;
				if( ! $instance->is_plugin_installed( $slug ) ) {
					$plugins['install'][$slug] = $plugin;
				} else {
					if( false !== $instance->does_plugin_have_update( $slug ) ) {
						$plugins['update'][$slug] = $plugin;
					}
					if( $instance->can_plugin_activate( $slug ) ) {
						$plugins['activate'][$slug] = $plugin;
					}
				}
			}
		}
		return $plugins;
	}

	public function setup_plugins() {
		if ( ! check_ajax_referer( 'whizzie_nonce', 'wpnonce' ) || empty( $_POST['slug'] ) ) {
			wp_send_json_error( array( 'error' => 1, 'message' => esc_html__( 'No Slug Found','fashion-outfit' ) ) );
		}
		$json = array();
		// send back some json we use to hit up TGM
		$plugins = $this->get_plugins();

		// what are we doing with this plugin?
		foreach ( $plugins['activate'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-activate',
					'action2'       => - 1,
					'message'       => esc_html__( 'Activating Plugin','fashion-outfit' ),
				);
				break;
			}
		}
		foreach ( $plugins['update'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-update',
					'action2'       => - 1,
					'message'       => esc_html__( 'Updating Plugin','fashion-outfit' ),
				);
				break;
			}
		}
		foreach ( $plugins['install'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-install',
					'action2'       => - 1,
					'message'       => esc_html__( 'Installing Plugin','fashion-outfit' ),
				);
				break;
			}
		}
		if ( $json ) {
			$json['hash'] = md5( serialize( $json ) ); // used for checking if duplicates happen, move to next plugin
			wp_send_json( $json );
		} else {
			wp_send_json( array( 'done' => 1, 'message' => esc_html__( 'Success','fashion-outfit' ) ) );
		}
		exit;
	}


	//................................................. MENUS .................................................//
	
	public function fashion_outfit_customizer_nav_menu() {
		// ------- Create Primary Menu --------
		$fashion_outfit_themename = 'Fashion Outfit'; // Ensure the theme name is set
		$fashion_outfit_menuname = $fashion_outfit_themename . ' Primary Menu';
		$fashion_outfit_menulocation = 'menu-1';
		$fashion_outfit_menu_exists = wp_get_nav_menu_object($fashion_outfit_menuname);

		if (!$fashion_outfit_menu_exists) {
			$fashion_outfit_menu_id = wp_create_nav_menu($fashion_outfit_menuname);

			// Home
			wp_update_nav_menu_item($fashion_outfit_menu_id, 0, array(
				'menu-item-title' => __('Home', 'fashion-outfit'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$fashion_outfit_page_about = get_page_by_path('about');
			if($fashion_outfit_page_about){
				wp_update_nav_menu_item($fashion_outfit_menu_id, 0, array(
					'menu-item-title' => __('About', 'fashion-outfit'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($fashion_outfit_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Services
			$fashion_outfit_page_services = get_page_by_path('services');
			if($fashion_outfit_page_services){
				wp_update_nav_menu_item($fashion_outfit_menu_id, 0, array(
					'menu-item-title' => __('Services', 'fashion-outfit'),
					'menu-item-classes' => 'services',
					'menu-item-url' => get_permalink($fashion_outfit_page_services),
					'menu-item-status' => 'publish'
				));
			}

			// Blog
			$fashion_outfit_page_blog = get_page_by_path('blog');
			if($fashion_outfit_page_blog){
				wp_update_nav_menu_item($fashion_outfit_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'fashion-outfit'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($fashion_outfit_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// Contact Us
			$fashion_outfit_page_contact = get_page_by_path('contact');
			if($fashion_outfit_page_contact){
				wp_update_nav_menu_item($fashion_outfit_menu_id, 0, array(
					'menu-item-title' => __('Contact Us', 'fashion-outfit'),
					'menu-item-classes' => 'contact',
					'menu-item-url' => get_permalink($fashion_outfit_page_contact),
					'menu-item-status' => 'publish'
				));
			}

			// Assign menu to location if not set
			if (!has_nav_menu($fashion_outfit_menulocation)) {
				$fashion_outfit_locations = get_theme_mod('nav_menu_locations');
				$fashion_outfit_locations[$fashion_outfit_menulocation] = $fashion_outfit_menu_id; // Use $fashion_outfit_menu_id here
				set_theme_mod('nav_menu_locations', $fashion_outfit_locations);
			}
		}
	}

	public function fashion_outfit_social_menu() {

		// ------- Create Social Menu --------
		$fashion_outfit_menuname = $fashion_outfit_themename . 'Social Menu';
		$fashion_outfit_menulocation = 'social-menu';
		$fashion_outfit_menu_exists = wp_get_nav_menu_object( $fashion_outfit_menuname );

		if( !$fashion_outfit_menu_exists){
			$fashion_outfit_menu_id = wp_create_nav_menu($fashion_outfit_menuname);

			wp_update_nav_menu_item( $fashion_outfit_menu_id, 0, array(
				'menu-item-title'  => __( 'Facebook', 'fashion-outfit' ),
				'menu-item-url'    => 'https://www.facebook.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $fashion_outfit_menu_id, 0, array(
				'menu-item-title'  => __( 'Pinterest', 'fashion-outfit' ),
				'menu-item-url'    => 'https://www.pinterest.com',
				'menu-item-status' => 'publish',
			) );
	
			wp_update_nav_menu_item( $fashion_outfit_menu_id, 0, array(
				'menu-item-title'  => __( 'Twitter', 'fashion-outfit' ),
				'menu-item-url'    => 'https://www.twitter.com',
				'menu-item-status' => 'publish',
			) );
	
			wp_update_nav_menu_item( $fashion_outfit_menu_id, 0, array(
				'menu-item-title'  => __( 'Youtube', 'fashion-outfit' ),
				'menu-item-url'    => 'https://www.youtube.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $fashion_outfit_menu_id, 0, array(
				'menu-item-title'  => __( 'Instagram', 'fashion-outfit' ),
				'menu-item-url'    => 'https://www.instagram.com',
				'menu-item-status' => 'publish',
			) );

			if( !has_nav_menu( $fashion_outfit_menulocation ) ){
					$locations = get_theme_mod('nav_menu_locations');
					$locations[$fashion_outfit_menulocation] = $fashion_outfit_menu_id;
					set_theme_mod( 'nav_menu_locations', $locations );
			}
		}
	}

	/**
	* Imports the Demo Content
	* @since 1.1.0
	*/
	public function setup_widgets() {

		//................................................. MENU PAGES .................................................//
		
			$fashion_outfit_home_id='';
			$fashion_outfit_home_content = '';

			$fashion_outfit_home_title = 'Home';
			$fashion_outfit_home = array(
					'post_type' => 'page',
					'post_title' => $fashion_outfit_home_title,
					'post_content'  => $fashion_outfit_home_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_slug' => 'home'
			);
			$fashion_outfit_home_id = wp_insert_post($fashion_outfit_home);

			//Set the home page template
			add_post_meta( $fashion_outfit_home_id, '_wp_page_template', 'revolution-home.php' );

			//Set the static front page
			$fashion_outfit_home = get_page_by_title( 'Home' );
			update_option( 'page_on_front', $fashion_outfit_home->ID );
			update_option( 'show_on_front', 'page' );


			// Create a posts page and assign the template
			$fashion_outfit_blog_title = 'Blog';
			$fashion_outfit_blog_check = get_page_by_path('blog');
			if (!$fashion_outfit_blog_check) {
				$fashion_outfit_blog = array(
					'post_type'    => 'page',
					'post_title'   => $fashion_outfit_blog_title,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'blog' // Unique slug for the blog page
				);
				$fashion_outfit_blog_id = wp_insert_post($fashion_outfit_blog);

				// Set the posts page
				if (!is_wp_error($fashion_outfit_blog_id)) {
					update_option('page_for_posts', $fashion_outfit_blog_id);
				}
			}

			// Create a Contact Us page and assign the template
			$fashion_outfit_contact_title = 'Contact Us';
			$fashion_outfit_contact_check = get_page_by_path('contact');
			if (!$fashion_outfit_contact_check) {
				$fashion_outfit_contact = array(
					'post_type'    => 'page',
					'post_title'   => $fashion_outfit_contact_title,
					'post_content'   => '"More About The Free Fashion WordPress Theme"
										The Free Fashion WordPress Theme is fully responsive, meaning it looks great and functions perfectly on all devices, including desktops, tablets, and smartphones. This ensures that your fashion e-store can reach a wider audience, providing a consistent and enjoyable shopping experience across all platforms. Additionally, the Free Fashion WordPress Theme offers cross-browser compatibility, ensuring that your website performs well on all major web browsers, including Chrome, Firefox, Safari, and Edge. Social media integration is another essential feature, allowing you to connect your fashion website with various social media platforms such as Instagram, Facebook, Twitter, and Pinterest. This integration makes it easy to share your latest fashion arrivals, trends, and promotions with your followers, driving traffic back to your online store and increasing engagement with your brand.

										For those looking to sell fashion products directly from their website, the Free Fashion WordPress Theme is WooCommerce compatible. This e-commerce functionality allows you to set up an online store effortlessly, manage inventory, process payments, and handle shipping and taxes. The built-in image galleries are perfect for showcasing fashion collections, new arrivals, and seasonal trends, allowing customers to browse through high-quality images of your products. The Free Fashion WordPress Theme also includes sections for testimonials and reviews, which are crucial for building credibility and trust with your customers. The built-in blogging platform supports content marketing efforts, enabling you to share fashion tips, style guides, industry news, and other valuable content with your audience. This feature helps in improving SEO and driving organic traffic to your website.

										Furthermore, the Free Fashion WordPress Theme is translation-ready, making it easy to create a multilingual site to reach a global audience. This feature is particularly beneficial for fashion businesses looking to expand their market internationally. Secure and optimized codes ensure that your website runs smoothly and securely, providing a safe shopping environment for your customers. The Free Fashion WordPress Theme is a powerful and flexible tool for fashion e-commerce businesses. Its user-friendly design, comprehensive features, and elegant visual elements make it an ideal choice for anyone looking to create a professional and appealing online fashion store. Whether you’re into women’s fashion, men’s fashion, kids’ fashion, or any other niche, this theme provides the necessary tools to showcase your products, connect with your audience, and succeed in the competitive fashion industry.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'contact' // Unique slug for the Contact Us page
				);
				wp_insert_post($fashion_outfit_contact);
			}

			// Create a About page and assign the template
			$fashion_outfit_about_title = 'About';
			$fashion_outfit_about_check = get_page_by_path('about');
			if (!$fashion_outfit_about_check) {
				$fashion_outfit_about = array(
					'post_type'    => 'page',
					'post_title'   => $fashion_outfit_about_title,
					'post_content'   => '"More About The Free Fashion WordPress Theme"
										The Free Fashion WordPress Theme is fully responsive, meaning it looks great and functions perfectly on all devices, including desktops, tablets, and smartphones. This ensures that your fashion e-store can reach a wider audience, providing a consistent and enjoyable shopping experience across all platforms. Additionally, the Free Fashion WordPress Theme offers cross-browser compatibility, ensuring that your website performs well on all major web browsers, including Chrome, Firefox, Safari, and Edge. Social media integration is another essential feature, allowing you to connect your fashion website with various social media platforms such as Instagram, Facebook, Twitter, and Pinterest. This integration makes it easy to share your latest fashion arrivals, trends, and promotions with your followers, driving traffic back to your online store and increasing engagement with your brand.

										For those looking to sell fashion products directly from their website, the Free Fashion WordPress Theme is WooCommerce compatible. This e-commerce functionality allows you to set up an online store effortlessly, manage inventory, process payments, and handle shipping and taxes. The built-in image galleries are perfect for showcasing fashion collections, new arrivals, and seasonal trends, allowing customers to browse through high-quality images of your products. The Free Fashion WordPress Theme also includes sections for testimonials and reviews, which are crucial for building credibility and trust with your customers. The built-in blogging platform supports content marketing efforts, enabling you to share fashion tips, style guides, industry news, and other valuable content with your audience. This feature helps in improving SEO and driving organic traffic to your website.

										Furthermore, the Free Fashion WordPress Theme is translation-ready, making it easy to create a multilingual site to reach a global audience. This feature is particularly beneficial for fashion businesses looking to expand their market internationally. Secure and optimized codes ensure that your website runs smoothly and securely, providing a safe shopping environment for your customers. The Free Fashion WordPress Theme is a powerful and flexible tool for fashion e-commerce businesses. Its user-friendly design, comprehensive features, and elegant visual elements make it an ideal choice for anyone looking to create a professional and appealing online fashion store. Whether you’re into women’s fashion, men’s fashion, kids’ fashion, or any other niche, this theme provides the necessary tools to showcase your products, connect with your audience, and succeed in the competitive fashion industry.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'about' // Unique slug for the About page
				);
				wp_insert_post($fashion_outfit_about);
			}

			// Create a Services page and assign the template
			$fashion_outfit_services_title = 'Services';
			$fashion_outfit_services_check = get_page_by_path('services');
			if (!$fashion_outfit_services_check) {
				$fashion_outfit_services = array(
					'post_type'    => 'page',
					'post_title'   => $fashion_outfit_services_title,
					'post_content'   => '"More About The Free Fashion WordPress Theme"
										The Free Fashion WordPress Theme is fully responsive, meaning it looks great and functions perfectly on all devices, including desktops, tablets, and smartphones. This ensures that your fashion e-store can reach a wider audience, providing a consistent and enjoyable shopping experience across all platforms. Additionally, the Free Fashion WordPress Theme offers cross-browser compatibility, ensuring that your website performs well on all major web browsers, including Chrome, Firefox, Safari, and Edge. Social media integration is another essential feature, allowing you to connect your fashion website with various social media platforms such as Instagram, Facebook, Twitter, and Pinterest. This integration makes it easy to share your latest fashion arrivals, trends, and promotions with your followers, driving traffic back to your online store and increasing engagement with your brand.

										For those looking to sell fashion products directly from their website, the Free Fashion WordPress Theme is WooCommerce compatible. This e-commerce functionality allows you to set up an online store effortlessly, manage inventory, process payments, and handle shipping and taxes. The built-in image galleries are perfect for showcasing fashion collections, new arrivals, and seasonal trends, allowing customers to browse through high-quality images of your products. The Free Fashion WordPress Theme also includes sections for testimonials and reviews, which are crucial for building credibility and trust with your customers. The built-in blogging platform supports content marketing efforts, enabling you to share fashion tips, style guides, industry news, and other valuable content with your audience. This feature helps in improving SEO and driving organic traffic to your website.

										Furthermore, the Free Fashion WordPress Theme is translation-ready, making it easy to create a multilingual site to reach a global audience. This feature is particularly beneficial for fashion businesses looking to expand their market internationally. Secure and optimized codes ensure that your website runs smoothly and securely, providing a safe shopping environment for your customers. The Free Fashion WordPress Theme is a powerful and flexible tool for fashion e-commerce businesses. Its user-friendly design, comprehensive features, and elegant visual elements make it an ideal choice for anyone looking to create a professional and appealing online fashion store. Whether you’re into women’s fashion, men’s fashion, kids’ fashion, or any other niche, this theme provides the necessary tools to showcase your products, connect with your audience, and succeed in the competitive fashion industry.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'services' // Unique slug for the Services page
				);
				wp_insert_post($fashion_outfit_services);
			}


		//................................................. HEADER .................................................//

			set_theme_mod('fashion_outfit_topheader_text','GET 50% OFF ON BRAND AFFILIATED PRODUCTS, USE CODE ELBLOI');

			set_theme_mod('fashion_outfit_facebook_link_option','#');
			set_theme_mod('fashion_outfit_twitter_link_option','#');
			set_theme_mod('fashion_outfit_youtube_link_option','#');
			set_theme_mod('fashion_outfit_instagram_link_option','#');

			set_theme_mod('fashion_outfit_enable_slider',1);
			set_theme_mod('fashion_outfit_enable_new_arrivals',1);


		//................................................. SLIDER SECTION .................................................//

			for($fashion_outfit_i=1;$fashion_outfit_i<=3;$fashion_outfit_i++){
				set_theme_mod( 'fashion_outfit_slider_image'.$fashion_outfit_i,get_template_directory_uri().'/revolution/assets/images/slider'.$fashion_outfit_i.'.png' );
				set_theme_mod( 'fashion_outfit_slider_top_text'.$fashion_outfit_i, 'WELCOME TO LUXURY WORDPRES THEME' );
				set_theme_mod( 'fashion_outfit_slider_heading'.$fashion_outfit_i, 'The Most Pleasant Journey You Can Have' );
				set_theme_mod( 'fashion_outfit_slider_text'.$fashion_outfit_i, 'Lorem ipsum dolor sit amet, consectetur adipis cing elit, sed do eiusmod tempor incididunt ut labore et dolore magna.' );
				set_theme_mod( 'fashion_outfit_slider_button1_text'.$fashion_outfit_i, 'EXPLORE NOW' );
				set_theme_mod( 'fashion_outfit_slider_button1_link'.$fashion_outfit_i, '#' );
				set_theme_mod( 'fashion_outfit_slider_button2_text'.$fashion_outfit_i, 'KNOW MORE' );
				set_theme_mod( 'fashion_outfit_slider_button2_link'.$fashion_outfit_i, '#' );
			}

		//................................................. PRODUCT SECTION .................................................//

			set_theme_mod('fashion_outfit_product_top_heading','HAVE A LOOK AT');
			set_theme_mod('fashion_outfit_product_main_heading','Our Products');
			set_theme_mod('fashion_outfit_product_content','Lorem ipsum dolor sit amet, consectetur');

			$product_category= array(
				'Fashion' => array(
					'Urban Streetwear Collection',
					'Chic Summer Essentials',
					'Elegant Evening Gowns',
					'Minimalist Casual Looks',
					'Boho Festival Outfits',
					'Smart Workwear Staples',
					'Winter Layering Picks',
					'Vacation Styles'
				)
			);
			$k = 1;
			foreach ( $product_category as $product_cats => $products_name ) {

				// Insert porduct cats Start
				$content = 'Lorem ipsum dolor sit amet';
				$parent_category	=	wp_insert_term(
				$product_cats, // the term
				'product_cat', // the taxonomy
				array(
					'description'=> $content,
					'slug' => 'product_cat'.$k
				));

				$image_url = get_template_directory_uri().'/revolution/assets/images/slider1.png';

				$image_name= 'img'.$k.'.png';
				$upload_dir       = wp_upload_dir();
				// Set upload folder
				$image_data= file_get_contents($image_url);
				// Get image data
				$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name );
				// Generate unique name
				$filename= basename( $unique_file_name );
				// Create image file name

				// Check folder permission and define file location
				if( wp_mkdir_p( $upload_dir['path'] ) ) {
				$file = $upload_dir['path'] . '/' . $filename;
				} else {
				$file = $upload_dir['basedir'] . '/' . $filename;
				}

				// Create the image  file on the server
				if ( ! function_exists( 'WP_Filesystem' ) ) {
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
				}
				
				WP_Filesystem();
				global $wp_filesystem;
				
				if ( ! $wp_filesystem->put_contents( $file, $image_data, FS_CHMOD_FILE ) ) {
					wp_die( 'Error saving file!' );
				}
				
				// Check image file type
				$wp_filetype = wp_check_filetype( $filename, null );

				// Set attachment data
				$attachment = array(
				'post_mime_type' => $wp_filetype['type'],
				'post_title'     => sanitize_file_name( $filename ),
				'post_content'   => '',
				'post_type'     => 'product',
				'post_status'    => 'inherit'
				);

				// Create the attachment
				$attach_id = wp_insert_attachment( $attachment, $file, $post_id );

				// Include image.php
				require_once(ABSPATH . 'wp-admin/includes/image.php');

				// Define attachment metadata
				$attach_data = wp_generate_attachment_metadata( $attach_id, $file );

				// Assign metadata to attachment
				wp_update_attachment_metadata( $attach_id, $attach_data );

				update_woocommerce_term_meta( $parent_category['term_id'], 'thumbnail_id', $attach_id );

				// create Product START
				foreach ( $products_name as $key => $product_title ) {

					$content = 'Te obtinuit ut adepto satis somno.';
					// Create post object
					$my_post = array(
						'post_title'    => wp_strip_all_tags( $product_title ),
						'post_content'  => $content,
						'post_status'   => 'publish',
						'post_type'     => 'product',
					);

					// Insert the post into the database
					$post_id    = wp_insert_post($my_post);

					wp_set_object_terms( $post_id, 'product_cat' . $k, 'product_cat', true );

					update_post_meta( $post_id, '_price', "$999.00" );

					// Now replace meta w/ new updated value array
					$image_url = get_template_directory_uri().'/revolution/assets/images/'.str_replace( " ", "-", $product_title).'.png';

					echo $image_url . "<br>";

					$image_name       = $product_title.'.png';
					$upload_dir = wp_upload_dir();
					// Set upload folder
					$image_data = file_get_contents(esc_url($image_url));

					// Get image data
					$unique_file_name = wp_unique_filename($upload_dir['path'], $image_name);
					// Generate unique name
					$filename = basename($unique_file_name);
					// Create image file name

					// Check folder permission and define file location
					if (wp_mkdir_p($upload_dir['path'])) {
						$file = $upload_dir['path'].'/'.$filename;
					} else {
						$file = $upload_dir['basedir'].'/'.$filename;
					}

					// Create the image  file on the server
					if ( ! function_exists( 'WP_Filesystem' ) ) {
						require_once( ABSPATH . 'wp-admin/includes/file.php' );
					}
					
					WP_Filesystem();
					global $wp_filesystem;
					
					if ( ! $wp_filesystem->put_contents( $file, $image_data, FS_CHMOD_FILE ) ) {
						wp_die( 'Error saving file!' );
					}

					// Check image file type
					$wp_filetype = wp_check_filetype($filename, null);

					// Set attachment data
					$attachment = array(
						'post_mime_type' => $wp_filetype['type'],
						'post_title'     => sanitize_file_name($filename),
						'post_type'      => 'product',
						'post_status'    => 'inherit',
					);

					// Create the attachment
					$attach_id = wp_insert_attachment($attachment, $file, $post_id);

					// Include image.php
					require_once (ABSPATH.'wp-admin/includes/image.php');

					// Define attachment metadata
					$attach_data = wp_generate_attachment_metadata($attach_id, $file);

					// Assign metadata to attachment
					wp_update_attachment_metadata($attach_id, $attach_data);

					// And finally assign featured image to post
					set_post_thumbnail($post_id, $attach_id);
				}
				// Create product END
				++$k;
			}
	
	$this->fashion_outfit_social_menu();
	$this->fashion_outfit_customizer_nav_menu();
	}

	//guidline for about theme
	public function fashion_outfit_guide() {
		$display_string = '';
		//custom function about theme customizer
		$return = add_query_arg( array()) ;
		$theme = wp_get_theme( 'fashion-outfit' );
		?>
		<div class="wrapper-info get-stared-page-wrap">
			<div class="wrapper-info-content">
				<div class="buynow__">
					<h2><?php esc_html_e( 'Welcome to Fashion Outfit', 'fashion-outfit' ); ?> <span class="version">Version: <?php echo esc_html($theme['Version']);?></span></h2>
					<p><?php esc_html_e('The quick setup wizard will assist you in configuring your new website. This wizard will import the demo content.', 'fashion-outfit'); ?></p>
				</div>
				<div class="buynow_">
					<a target="_blank" class="buynow_themepage" href="<?php echo esc_url('https://www.revolutionwp.com/products/fashion-outfit-wordpress-theme'); ?>"><?php echo esc_html__('Go Premium Now', 'fashion-outfit'); ?></a>
				</div>
			</div>
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent open">
					<?php $this->wizard_page(); ?>
				</div>
			</div>
		</div>
	<?php }
}